﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.ObjectModel;

namespace AsyncAndSync.Web
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class TestService
    {
        public static TaskCollection Tasks = new TaskCollection();

        [OperationContract]
        public bool IsTaskCreated(string taskId)
        {
            return Tasks.Contains(taskId);
        }

        [OperationContract]
        public Task CreateTask(string taskId, string taskName)
        {
            Tasks.Add(new Task()
            {
                TaskId = taskId,
                TaskName = taskName
            });
            return Tasks[taskId];
        }

        [OperationContract]
        public Task GetTask(string taskId)
        {
            if (Tasks.Contains(taskId))
                return Tasks[taskId];
            return null;
        }
    }

    [DataContract]
    public class Task
    {
        [DataMember]
        public string TaskId { get; set; }
        [DataMember]
        public string TaskName { get; set; }
    }

    public class TaskCollection : KeyedCollection<string, Task>
    {
        protected override string GetKeyForItem(Task item)
        {
            return item.TaskId;
        }
    }
}
