﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using AsyncAndSync.Test;
using System.Threading;

namespace AsyncAndSync
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void ButtonTest1_Click(object sender, RoutedEventArgs e)
        {
            Test1();
        }

        private void ButtonTest2_Click(object sender, RoutedEventArgs e)
        {
            Test2();
        }

        private void ButtonTest3_Click(object sender, RoutedEventArgs e)
        {
            Test3();
        }

        private void ButtonTest4_Click(object sender, RoutedEventArgs e)
        {
            Test4();
        }

        private void Test1()
        {
            string taskId = "test id";
            Task task = null;
            //var isTaskCreated = CheckTaskCreated(taskId);
            //var isTaskCreated = CheckTaskCreatedBySleep(taskId);
            var isTaskCreated = CheckTaskCreatedByWaitOne(taskId);
            if (isTaskCreated)
            {
                //load task
                task = this.LoadTask(taskId);
            }
            else
            {
                var result = MessageBox.Show("任务没有创建，是否立即创建", "问题", MessageBoxButton.OKCancel);
                if (result == MessageBoxResult.OK)
                {
                    //create task
                    task = this.CreateTask(taskId, "test name");
                }
            }

            if (task != null)
            {
                //后续操作
            }
        }

        private bool CheckTaskCreated(string taskId)
        {
            //TestServiceClient client = new TestServiceClient();
            //return client.IsTaskCreated(taskId);//无该方法
            return false;
        }

        private Task LoadTask(string taskId)
        {
            //TestServiceClient client = new TestServiceClient();
            //return client.GetTask(taskId);//无该方法
            return null;
        }

        private Task CreateTask(string taskId, string taskName)
        {
            //TestServiceClient client = new TestServiceClient();
            //return client.CreateTask(taskId, taskName);//无该方法
            return null;
        }

        private Task task;
        private void Test2()
        {
            string taskId = "test id";
            TestServiceClient client = new TestServiceClient();
            client.IsTaskCreatedCompleted += new EventHandler<IsTaskCreatedCompletedEventArgs>(client_IsTaskCreatedCompleted);
            client.IsTaskCreatedAsync(taskId, taskId);
        }

        void client_IsTaskCreatedCompleted(object sender, IsTaskCreatedCompletedEventArgs e)
        {
            TestServiceClient client = new TestServiceClient();
            if (e.Result)
            {
                client.GetTaskCompleted += new EventHandler<GetTaskCompletedEventArgs>(client_GetTaskCompleted);
                client.GetTaskAsync((string)e.UserState);
            }
            else
            {
                client.CreateTaskCompleted += new EventHandler<CreateTaskCompletedEventArgs>(client_CreateTaskCompleted);
                client.CreateTaskAsync((string)e.UserState, "test name");
            }
        }

        void client_GetTaskCompleted(object sender, GetTaskCompletedEventArgs e)
        {
            task = e.Result;
            //后续操作
        }

        void client_CreateTaskCompleted(object sender, CreateTaskCompletedEventArgs e)
        {
            task = e.Result;
            //后续操作
        }

        private bool CheckTaskCreatedBySleep(string taskId)
        {
            bool? isTaskCreated = null;
            TestServiceClient client = new TestServiceClient();
            client.IsTaskCreatedCompleted += (s, args) =>
            {
                isTaskCreated = args.Result;
            };
            client.IsTaskCreatedAsync(taskId);
            while (isTaskCreated == null)
                Thread.Sleep(100);
            return isTaskCreated.Value;
        }

        private bool CheckTaskCreatedByWaitOne(string taskId)
        {
            bool? isTaskCreated = null;
            var resetEvent = new ManualResetEvent(false);
            TestServiceClient client = new TestServiceClient();
            client.IsTaskCreatedCompleted += (s, args) =>
            {
                isTaskCreated = args.Result;
                resetEvent.Set();
            };
            client.IsTaskCreatedAsync(taskId);
            resetEvent.WaitOne();
            return isTaskCreated.Value;
        }

        private void Test3()
        {
            CheckTaskCreatedAsync("");
        }

        private void CheckTaskCreatedAsync(string taskId)
        {
            MessageBox.Show("call thread:" + Thread.CurrentThread.ManagedThreadId.ToString());
            TestServiceClient client = new TestServiceClient();
            client.IsTaskCreatedCompleted += (s, args) =>
            {
                MessageBox.Show("callback thread:" + Thread.CurrentThread.ManagedThreadId.ToString());
            };
            client.IsTaskCreatedAsync(taskId);
        }
        //封装方式
        private void GetTaskAsync(string taskId, Action<Task> callback)
        {
            TestServiceClient client = new TestServiceClient();
            client.GetTaskCompleted += (s, args) =>
            {
                callback(args.Result);
            };
            client.GetTaskAsync(taskId);
        }
        //调用方式
        private void Test4()
        {
            var client = new TestServiceClient();
            var proxy = new ServiceProxy<TestServiceClient>(client);
            object bizObject = new object();
            proxy.PerformFunction(client.IsTaskCreatedAsync, "task id", (bool isTaskCreated, Exception err) =>
            {
                if (err == null)
                {
                    MessageBox.Show("IsTaskCreatedAsync");
                    //do work with task
                    if (isTaskCreated)
                    {
                        proxy.PerformFunction(client.GetTaskAsync, "task id", (Task task, Exception error) =>
                        {
                            if (error == null)
                            {
                                MessageBox.Show("GetTaskAsync");
                            }
                        });
                    }
                    else
                    {
                        proxy.PerformFunction(client.CreateTaskAsync, "task id", "task name", (Task task, Exception e) =>
                        {
                            if (e == null)
                            {
                                MessageBox.Show("CreateTaskAsync");
                            }
                        });
                    }
                }
                else
                {
                    //error handle
                }
            });
            //client.GetTaskAsync("task id", (task) =>
            //{
            //    //bizObject.xxx()
            //    client.DoWorkAsync(() =>
            //    {
            //        //bizObject.yyy()
            //        client.DoOtherWorkAsync(() =>
            //        {
            //            //bizObject.zzz()
            //        });
            //    });
            //});
        }
    }

    public class MyTestServiceClient
    {
        private TestServiceClient client;

        public MyTestServiceClient()
        {
            TestServiceClient client = new TestServiceClient();
            client.GetTaskCompleted += new EventHandler<GetTaskCompletedEventArgs>(client_GetTaskCompleted);
        }

        void client_GetTaskCompleted(object sender, GetTaskCompletedEventArgs e)
        {
            var action = e.UserState as Action<Task>;
            if (action != null) action(e.Result);
        }
        public void GetTaskAsync(string taskId, Action<Task> callback)
        {
            client.GetTaskAsync(taskId, callback);
        }
        //...
    }
}
